////////////////////////////////////////////////
//CFGHexEdit V.1.00
//Programma realizzato da Francesco Germinara
//www.germinara.it  2005 FREEWARE
//info@germinara.it
//http://www.germinara.it
//programmatore PINEROLO TORINO ITALIA
//Data realizzazione: 10/luglio/2005
////////////////////////////////////////////////
//
// Thanks to Eugene Pavlov (http://www.softerra.com) for the good job on the 
// ACTIVEX HEX EDIT CONTRON. 
//  
// Some Method are taken from Eugene Pavlov souce code.
//
// CFGHexEdit.cpp : implementation file
//

#include "stdafx.h"
#include "FGEdit.h"

#include "FGEditDoc.h"
#include "FGEditView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include "CDlgHexEditorInDialogTest.h"
#include ".\fgeditview.h"

/////////////////////////////////////////////////////////////////////////////
// CFGEditView

IMPLEMENT_DYNCREATE(CFGEditView, CView)

BEGIN_MESSAGE_MAP(CFGEditView, CView)
	//{{AFX_MSG_MAP(CFGEditView)
	ON_WM_SIZE()
	ON_WM_ERASEBKGND()
	ON_COMMAND(ID_TEST_READ, OnTestRead)
	ON_COMMAND(ID_FUNCTION_SETALLBYTESTO0XFF, OnFunctionSetallbytesto0xff)
	ON_COMMAND(ID_FUNCTION_OPENFILE, OnFunctionOpenfile)
	ON_COMMAND(ID_FUNCTION_SAVEFILE, OnFunctionSavefile)
	ON_WM_SETFOCUS()
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
 ON_COMMAND(ID_FUNCTION_OPENINDIALOGSAMPLE, OnFunctionOpenindialogsample)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFGEditView construction/destruction

CFGEditView::CFGEditView()
{
	// TODO: add construction code here

}

CFGEditView::~CFGEditView()
{
}

BOOL CFGEditView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

		return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CFGEditView drawing

void CFGEditView::OnDraw(CDC* pDC)
{
	CFGEditDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	
}

/////////////////////////////////////////////////////////////////////////////
// CFGEditView printing

BOOL CFGEditView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CFGEditView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CFGEditView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CFGEditView diagnostics

#ifdef _DEBUG
void CFGEditView::AssertValid() const
{
	CView::AssertValid();
}

void CFGEditView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CFGEditDoc* CFGEditView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CFGEditDoc)));
	return (CFGEditDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CFGEditView message handlers

void CFGEditView::OnInitialUpdate() 
{
	CView::OnInitialUpdate();

	CRect rcSize;
	GetClientRect(rcSize);
	theEditor.Create(rcSize,this,0x01);

	CByteArray data;
	for(int i=0; i < 4096; i++)
		data.Add(i);

	theEditor.SetData(data);

}

void CFGEditView::OnSize(UINT nType, int cx, int cy) 
{
	CView::OnSize(nType, cx, cy);
	
	if(::IsWindow(theEditor.m_hWnd)){
	 CRect rcSize;
	 GetClientRect(rcSize);
	 theEditor.MoveWindow(rcSize);
	}
	
}

BOOL CFGEditView::OnEraseBkgnd(CDC* pDC) 
{
	
	return TRUE;
}

void CFGEditView::OnTestRead() 
{
	theEditor.SetAllDataValue(0x00);
}

void CFGEditView::OnFunctionSetallbytesto0xff() 
{
	theEditor.SetAllDataValue(0xFF);

	
}

void CFGEditView::OnFunctionOpenfile() 
{
	theEditor.OnLoadFile();
	
}

void CFGEditView::OnFunctionSavefile() 
{
	theEditor.OnSaveFile();
	
}


void CFGEditView::OnSetFocus(CWnd* pOldWnd) 
{
	CView::OnSetFocus(pOldWnd);
	
	theEditor.SetFocus();
	
}


void CFGEditView::OnFunctionOpenindialogsample()
 {
  CDlgHexEditorInDialogTest dlgHexEditorInDialogTest(this);
  dlgHexEditorInDialogTest.DoModal();
 }
